searchData={"items":[{"type":"module","title":"Algoliax","doc":"Algoliax is wrapper for Algolia api","ref":"Algoliax.html"},{"type":"module","title":"Configuration - Algoliax","doc":"Algoliax needs only `:api_key` and `application_id` config. These configs can either be on config files or using environment varialble `\"ALGOLIA_API_KEY\"` and `\"ALGOLIA_APPLICATION_ID\"`.\n\n    config :algoliax,\n      api_key: \"\",\n      application_id: \"\"","ref":"Algoliax.html#module-configuration"},{"type":"function","title":"Algoliax.generate_secured_api_key/2","doc":"Generate a secured api key with filter","ref":"Algoliax.html#generate_secured_api_key/2"},{"type":"function","title":"Examples - Algoliax.generate_secured_api_key/2","doc":"Algoliax.generate_secured_api_key(\"api_key\", %{filters: \"reference:10\"})\n    Algoliax.generate_secured_api_key(\"api_key\", %{filters: \"reference:10 OR nickname:john\"})","ref":"Algoliax.html#generate_secured_api_key/2-examples"},{"type":"function","title":"Algoliax.generate_secured_api_key!/2","doc":"Same as `generate_secured_api_key/2` but returns the key or raises if invalid params","ref":"Algoliax.html#generate_secured_api_key!/2"},{"type":"function","title":"Examples - Algoliax.generate_secured_api_key!/2","doc":"Algoliax.generate_secured_api_key!(\"api_key\", %{filters: \"reference:10\"})\n    Algoliax.generate_secured_api_key!(\"api_key\", %{filters: \"reference:10 OR nickname:john\"})","ref":"Algoliax.html#generate_secured_api_key!/2-examples"},{"type":"function","title":"Algoliax.wait_task/1","doc":"Wait for a task to be published on Algolia side. Work with all indexer function except `reindex_atomic/0`","ref":"Algoliax.html#wait_task/1"},{"type":"function","title":"Examples - Algoliax.wait_task/1","doc":"MyApp.People.save_object(%MyApp.People{id: 1}) |> Algoliax.wait_task()","ref":"Algoliax.html#wait_task/1-examples"},{"type":"function","title":"Algoliax.with_user_ip/2","doc":"Forward user ip to algolia operations\n\n    Algoliax.with_user_ip(\"192.168.0.1\", fn ->\n      MyIndexer.search(\"test\")\n    end)","ref":"Algoliax.html#with_user_ip/2"},{"type":"behaviour","title":"Algoliax.Indexer","doc":"","ref":"Algoliax.Indexer.html"},{"type":"behaviour","title":"Usage - Algoliax.Indexer","doc":"- `:index_name`: specificy the index or a list of indexes where the object will be added on. **Required**\n- `:object_id`: specify the attribute used to as algolia objectID. Default `:id`.\n- `:repo`: Specify an Ecto repo to be use to fecth records. Default `nil`\n- `:cursor_field`: specify the column to be used to order and go through a given table. Default `:id`\n- `:schemas`: Specify which schemas used to populate index, Default: `[__CALLER__]`\n- `:default_filters`: Specify default filters to be used when reindex without providing a query. Must be a map or a function name (that returns a map). Default: `%{}`.\n- `:algolia`: Any valid Algolia settings, using snake case or camel case. Ex: Algolia `attributeForFaceting` can be configured with `:attribute_for_faceting`\n\nOn first call to Algolia, we check that the settings on Algolia are up to date.","ref":"Algoliax.Indexer.html#module-usage"},{"type":"behaviour","title":"Example - Algoliax.Indexer","doc":"defmodule People do\n      use Algoliax.Indexer,\n        index_name: :people,\n        object_id: :reference,\n        algolia: [\n          attribute_for_faceting: [\"age\"],\n          custom_ranking: [\"desc(updated_at)\"]\n        ]\n\n      defstruct reference: nil, last_name: nil, first_name: nil, age: nil\n    end","ref":"Algoliax.Indexer.html#module-example"},{"type":"behaviour","title":"Customize object - Algoliax.Indexer","doc":"By default the object contains only algolia `objectID`. To add more attributes to objects, override `build_object/1` functions to return a Map (objectID is automatically set by Algoliax)\n\n    defmodule People do\n      use Algoliax.Indexer,\n        index_name: :people,\n        object_id: :reference,\n        algolia: [\n          attribute_for_faceting: [\"age\"],\n          custom_ranking: [\"desc(updated_at)\"]\n        ]\n\n      defstruct reference: nil, last_name: nil, first_name: nil, age: nil\n\n      @impl Algoliax.Indexer\n      def build_object(person) do\n        %{\n          age: person.age,\n          last_name: person.last_name,\n          first_name: person.first_name\n        }\n      end\n    end","ref":"Algoliax.Indexer.html#module-customize-object"},{"type":"behaviour","title":"Schemas - Algoliax.Indexer","doc":"`:schemas` options allows to define a list of module you want to index into the current index. By default only the module defining the indexer.\n\n    defmodule Global do\n      use Algoliax.Indexer,\n        index_name: :people,\n        object_id: :reference,\n        schemas: [People, Animal],\n        algolia: [\n          attribute_for_faceting: [\"age\"],\n          custom_ranking: [\"desc(updated_at)\"]\n        ]\n\n    end\n\nThe example above will introduce a compile-time dependency on `People` and `Animal`, so it is preferable to provide the name of a function that will return the list of modules.\n\n    defmodule Global do\n      use Algoliax.Indexer,\n        index_name: :people,\n        object_id: :reference,\n        schemas: :index_schemas,\n        algolia: [\n          attribute_for_faceting: [\"age\"],\n          custom_ranking: [\"desc(updated_at)\"]\n        ]\n\n      def index_schemas, do: [People, Animal]\n    end\n\n  This option allows to define also the preloads use during `reindex`/`reindex_atomic` (preload on `save_object` and `save_objects` have to be done manually)\n\n      defmodule People do\n        use Algoliax.Indexer,\n          index_name: :people,\n          object_id: :reference,\n          schemas: [\n            {__MODULE__, [:animals]}\n          ]\n          algolia: [\n            attribute_for_faceting: [\"age\"],\n            custom_ranking: [\"desc(updated_at)\"]\n          ]\n\n      end","ref":"Algoliax.Indexer.html#module-schemas"},{"type":"behaviour","title":"Default filters - Algoliax.Indexer","doc":"`:default_filters` allows you to define a list of filters that will be automatically applied when performing `reindex` without query, or `reindex_atomic`.\n If not provided, it defaults to `%{}`, meaning it will not apply any filter and fetch the entire repo for all schemas.\n You can provide either a map or a function name that returns a map.\n\n    defmodule Global do\n      use Algoliax.Indexer,\n        index_name: :people,\n        object_id: :reference,\n        schemas: [People, Animal],\n        default_filters: %{where: [age: 18]},\n        algolia: [\n          attribute_for_faceting: [\"age\"],\n          custom_ranking: [\"desc(updated_at)\"]\n        ]\n    end\n\nThe map must be a valid Ecto query but can be customized/nested by schema:\n\n    defmodule Global do\n      use Algoliax.Indexer,\n        index_name: :people,\n        object_id: :reference,\n        schemas: [People, Animal],\n        default_filters: :get_filters,\n        algolia: [\n          attribute_for_faceting: [\"age\"],\n          custom_ranking: [\"desc(updated_at)\"]\n        ]\n\n      def get_filters do\n        %{\n          People => where: [age: 18], # <-- Custom filter for People\n          :where => [kind: \"cat\"]  # <-- Default filter for other schemas\n      end\n    end","ref":"Algoliax.Indexer.html#module-default-filters"},{"type":"callback","title":"Algoliax.Indexer.build_object/1","doc":"Build the object sent to algolia. By default the object contains only `objectID` set by Algoliax.Indexer\nbuild_object/2 provides the index name for the ongoing build","ref":"Algoliax.Indexer.html#c:build_object/1"},{"type":"callback","title":"Example - Algoliax.Indexer.build_object/1","doc":"@impl Algoliax.Indexer\n    def build_object(person) do\n      %{\n        age: person.age,\n        last_name: person.last_name,\n        first_name: person.first_name\n      }\n    end\n\n    @impl Algoliax.Indexer\n    def build_object(person, _index_name) do\n      %{\n        age: person.age,\n        last_name: person.last_name,\n        first_name: person.first_name\n      }\n    end","ref":"Algoliax.Indexer.html#c:build_object/1-example"},{"type":"callback","title":"Algoliax.Indexer.build_object/2","doc":"","ref":"Algoliax.Indexer.html#c:build_object/2"},{"type":"callback","title":"Algoliax.Indexer.configure_index/0","doc":"Configure index","ref":"Algoliax.Indexer.html#c:configure_index/0"},{"type":"callback","title":"Algoliax.Indexer.delete_by/1","doc":"Delete objects from algolia. By passing a matching filter query, the records are retrieved and deleted.[Filters](https://www.algolia.com/doc/api-reference/api-parameters/filters/)","ref":"Algoliax.Indexer.html#c:delete_by/1"},{"type":"callback","title":"Example: - Algoliax.Indexer.delete_by/1","doc":"People.delete_by(\"age > 18\")","ref":"Algoliax.Indexer.html#c:delete_by/1-example"},{"type":"callback","title":"Algoliax.Indexer.delete_index/0","doc":"Delete index","ref":"Algoliax.Indexer.html#c:delete_index/0"},{"type":"callback","title":"Algoliax.Indexer.delete_object/1","doc":"Delete object from algolia. By passing the model, the object is retrieved using the object_id configured","ref":"Algoliax.Indexer.html#c:delete_object/1"},{"type":"callback","title":"Example - Algoliax.Indexer.delete_object/1","doc":"people = %People{reference: 10, last_name: \"Doe\", first_name: \"John\", age: 20}\n\n    People.delete_object(people)","ref":"Algoliax.Indexer.html#c:delete_object/1-example"},{"type":"callback","title":"Algoliax.Indexer.get_object/1","doc":"Fetch object from algolia. By passing the model, the object is retrieved using the object_id configured","ref":"Algoliax.Indexer.html#c:get_object/1"},{"type":"callback","title":"Example - Algoliax.Indexer.get_object/1","doc":"people = %People{reference: 10, last_name: \"Doe\", first_name: \"John\", age: 20}\n\n    People.get_object(people)","ref":"Algoliax.Indexer.html#c:get_object/1-example"},{"type":"callback","title":"Algoliax.Indexer.get_object_id/1","doc":"Override this function to provide custom objectID for the model","ref":"Algoliax.Indexer.html#c:get_object_id/1"},{"type":"callback","title":"Example - Algoliax.Indexer.get_object_id/1","doc":"@impl Algoliax.Indexer\n    def get_object_id(%Cat{id: id}), do: \"Cat:\" <> to_string(id)\n    def get_object_id(%Dog{id: id}), do: \"Dog:\" <> to_string(id)","ref":"Algoliax.Indexer.html#c:get_object_id/1-example"},{"type":"callback","title":"Algoliax.Indexer.get_settings/0","doc":"Get index settings from Algolia","ref":"Algoliax.Indexer.html#c:get_settings/0"},{"type":"callback","title":"Algoliax.Indexer.reindex/1","doc":"Reindex all objects ([Ecto](https://hexdocs.pm/ecto/Ecto.html) specific)","ref":"Algoliax.Indexer.html#c:reindex/1"},{"type":"callback","title":"Example - Algoliax.Indexer.reindex/1","doc":"People.reindex(query)\n\nAvailable options:\n\n- `:force_delete`: delete objects where `to_be_indexed?` is `false`","ref":"Algoliax.Indexer.html#c:reindex/1-example"},{"type":"callback","title":"Algoliax.Indexer.reindex/2","doc":"Reindex a subset of records by providing an Ecto query or query filters as a Map([Ecto](https://hexdocs.pm/ecto/Ecto.html) specific)","ref":"Algoliax.Indexer.html#c:reindex/2"},{"type":"callback","title":"Example - Algoliax.Indexer.reindex/2","doc":"import Ecto.Query\n\n    query = from(\n      p in People,\n      where: p.age > 45\n    )\n\n    People.reindex(query)\n\n    # OR\n    filters = %{where: [name: \"john\"]}\n    People.reindex(filters)\n\nAvailable options:\n\n- `:force_delete`: delete objects that are in query and where `to_be_indexed?` is false\n\n> NOTE: filters as Map supports only `:where` and equality","ref":"Algoliax.Indexer.html#c:reindex/2-example"},{"type":"callback","title":"Algoliax.Indexer.reindex_atomic/0","doc":"Reindex atomically ([Ecto](https://hexdocs.pm/ecto/Ecto.html) specific)","ref":"Algoliax.Indexer.html#c:reindex_atomic/0"},{"type":"callback","title":"Algoliax.Indexer.save_object/1","doc":"Add/update object. The object is added/updated to algolia with the object_id configured.","ref":"Algoliax.Indexer.html#c:save_object/1"},{"type":"callback","title":"Example - Algoliax.Indexer.save_object/1","doc":"people = %People{reference: 10, last_name: \"Doe\", first_name: \"John\", age: 20},\n\n    People.save_object(people)\n\n    iex> PeopleWithMultipleIndexes.save_object(people)\n    {:ok, [%{index_name: \"people\", responses: [%{\"exhaustiveNbHits\" => true, ...}, ...]}, ...]}","ref":"Algoliax.Indexer.html#c:save_object/1-example"},{"type":"callback","title":"Algoliax.Indexer.save_objects/2","doc":"Save multiple object at once","ref":"Algoliax.Indexer.html#c:save_objects/2"},{"type":"callback","title":"Options - Algoliax.Indexer.save_objects/2","doc":"* `:force_delete` - if `true` will trigger a \"deleteObject\" on object that must not be indexed. Default `false`","ref":"Algoliax.Indexer.html#c:save_objects/2-options"},{"type":"callback","title":"Example - Algoliax.Indexer.save_objects/2","doc":"peoples = [\n      %People{reference: 10, last_name: \"Doe\", first_name: \"John\", age: 20},\n      %People{reference: 89, last_name: \"Einstein\", first_name: \"Albert\", age: 65}\n    ]\n\n    People.save_objects(peoples)\n    People.save_objects(peoples, force_delete: true)","ref":"Algoliax.Indexer.html#c:save_objects/2-example"},{"type":"callback","title":"Algoliax.Indexer.search/2","doc":"Search for index values","ref":"Algoliax.Indexer.html#c:search/2"},{"type":"callback","title":"Example - Algoliax.Indexer.search/2","doc":"iex> People.search(\"John\")\n\n    {:ok,\n      %{\n        \"exhaustiveNbHits\" => true,\n        \"hits\" => [\n          %{\n            \"_highlightResult\" => %{\n              \"full_name\" => %{\n                \"fullyHighlighted\" => false,\n                \"matchLevel\" => \"full\",\n                \"matchedWords\" => [\"john\"],\n                \"value\" => \"Pierre  Jon es\"\n              }\n            },\n            \"age\" => 69,\n            \"first_name\" => \"Pierre\",\n            \"full_name\" => \"Pierre Jones\",\n            \"indexed_at\" => 1570908223,\n            \"last_name\" => \"Jones\",\n            \"objectID\" => \"b563deb6-2a06-4428-8e5a-ca1ecc08f4e2\"\n          },\n          %{\n            \"_highlightResult\" => %{\n              \"full_name\" => %{\n                \"fullyHighlighted\" => false,\n                \"matchLevel\" => \"full\",\n                \"matchedWords\" => [\"john\"],\n                \"value\" => \"Glennie  Jon es\"\n              }\n            },\n            \"age\" => 27,\n            \"first_name\" => \"Glennie\",\n            \"full_name\" => \"Glennie Jones\",\n            \"indexed_at\" => 1570908223,\n            \"last_name\" => \"Jones\",\n            \"objectID\" => \"58e8ff8d-2794-41e1-a4ef-6f8db8d432b6\"\n          },\n          ...\n        ],\n    \"hitsPerPage\" => 20,\n    \"nbHits\" => 16,\n    \"nbPages\" => 1,\n    \"page\" => 0,\n    \"params\" => \"query=john\",\n    \"processingTimeMS\" => 1,\n    \"query\" => \"john\"\n    }}\n\n    iex> PeopleWithMultipleIndexes.search(\"John\")\n    {:ok, [%{index_name: \"people\", responses: [%{\"exhaustiveNbHits\" => true, ...}, ...]}, ...]}","ref":"Algoliax.Indexer.html#c:search/2-example"},{"type":"callback","title":"Algoliax.Indexer.search_facet/3","doc":"Search for facet values","ref":"Algoliax.Indexer.html#c:search_facet/3"},{"type":"callback","title":"Example - Algoliax.Indexer.search_facet/3","doc":"iex> People.search_facet(\"age\")\n    {:ok,\n      %{\n        \"exhaustiveFacetsCount\" => true,\n        \"facetHits\" => [\n          %{\"count\" => 22, \"highlighted\" => \"46\", \"value\" => \"46\"},\n          %{\"count\" => 21, \"highlighted\" => \"38\", \"value\" => \"38\"},\n          %{\"count\" => 19, \"highlighted\" => \"54\", \"value\" => \"54\"},\n          %{\"count\" => 19, \"highlighted\" => \"99\", \"value\" => \"99\"},\n          %{\"count\" => 18, \"highlighted\" => \"36\", \"value\" => \"36\"},\n          %{\"count\" => 18, \"highlighted\" => \"45\", \"value\" => \"45\"},\n          %{\"count\" => 18, \"highlighted\" => \"52\", \"value\" => \"52\"},\n          %{\"count\" => 18, \"highlighted\" => \"56\", \"value\" => \"56\"},\n          %{\"count\" => 18, \"highlighted\" => \"59\", \"value\" => \"59\"},\n          %{\"count\" => 18, \"highlighted\" => \"86\", \"value\" => \"86\"}\n        ],\n        \"processingTimeMS\" => 1\n      }}\n\n    iex> PeopleWithMultipleIndexes.search_facet(\"age\")\n    {:ok, [%{index_name: \"people\", responses: [%{\"exhaustiveNbHits\" => true, ...}, ...]}, ...]}","ref":"Algoliax.Indexer.html#c:search_facet/3-example"},{"type":"callback","title":"Algoliax.Indexer.to_be_indexed?/1","doc":"Check if current object must be indexed or not. By default it's always true. To override this behaviour override this function in your model","ref":"Algoliax.Indexer.html#c:to_be_indexed?/1"},{"type":"callback","title":"Example - Algoliax.Indexer.to_be_indexed?/1","doc":"defmodule People do\n      use Algoliax.Indexer,\n        index_name: :people,\n        object_id: :reference,\n        algolia: [\n          attribute_for_faceting: [\"age\"],\n          custom_ranking: [\"desc(update_at)\"]\n        ]\n\n      #....\n\n      @impl Algoliax.Indexer\n      def to_be_indexed?(model) do\n        model.age > 50\n      end\n    end","ref":"Algoliax.Indexer.html#c:to_be_indexed?/1-example"},{"type":"module","title":"Algoliax.Response","doc":"Algolia API response","ref":"Algoliax.Response.html"},{"type":"function","title":"Algoliax.Response.new/2","doc":"","ref":"Algoliax.Response.html#new/2"},{"type":"type","title":"Algoliax.Response.t/0","doc":"","ref":"Algoliax.Response.html#t:t/0"},{"type":"module","title":"Algoliax.Responses","doc":"Algolia API responses","ref":"Algoliax.Responses.html"},{"type":"type","title":"Algoliax.Responses.t/0","doc":"","ref":"Algoliax.Responses.html#t:t/0"},{"type":"module","title":"Algoliax.TemporaryIndexer","doc":"Execute save_object(s) on temporary index to keep it synchronized with main index","ref":"Algoliax.TemporaryIndexer.html"},{"type":"function","title":"Algoliax.TemporaryIndexer.run/5","doc":"","ref":"Algoliax.TemporaryIndexer.html#run/5"},{"type":"exception","title":"Algoliax.AlgoliaApiError","doc":"Raise Algolia API error","ref":"Algoliax.AlgoliaApiError.html"},{"type":"exception","title":"Algoliax.InvalidApiKeyParamsError","doc":"Raise when trying to generate a secured api key with invalid params","ref":"Algoliax.InvalidApiKeyParamsError.html"},{"type":"exception","title":"Algoliax.MissingIndexNameError","doc":"Raise when trying to use algoliax without defining an index name","ref":"Algoliax.MissingIndexNameError.html"},{"type":"exception","title":"Algoliax.MissingRepoError","doc":"Raise when trying to use ecto specific functions without defining a repo","ref":"Algoliax.MissingRepoError.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.8.2 - 2024-09-16 - Changelog","doc":"- Upgrading all dependencies\n- Added `dependabot` to the repository","ref":"changelog.html#v0-8-2-2024-09-16"},{"type":"extras","title":"v0.8.1 - 2024-09-11 - Changelog","doc":"#### New\n\n- Added new **optional** settings `default_filters` to be applied automatically when calling `reindex` without query\n  or `reindex_atomic`. Defaults to `%{}` which was the previous behavior.\n\n```elixir\ndefmodule BlondeBeerIndexer do\n  use Algoliax.Indexer,\n    index_name: :blonde_beers,\n    object_id: :name,\n    schemas: [Beer],\n    default_filters: %{where: [kind: \"blonde\"]} # <--- can be a map\nend\n\ndefmodule BeerIndexer do\n  use Algoliax.Indexer,\n    index_name: :various_beers,\n    object_id: :name,\n    schemas: [Beer1, Beer2, Beer3],\n    default_filters: :get_filters # <--- can be a function\n\n  def get_filters do\n    %{\n      Beer1 => %{where: [kind: \"blonde\"]},  # <--- custom filter for Beer1\n      :where => [kind: \"brune\"] # <--- Will be used for Beer2 and Beer3\n    }\n  end\nend\n```\n\n#### Contributing\n\n- New `CONTRIBUTING.md` file\n- Simplified the `config/test.exs` file\n- Provide a `.env.example` file to help contributors to setup their environment","ref":"changelog.html#v0-8-1-2024-09-11"},{"type":"extras","title":"v0.8.0 - 2024-09-11 - Changelog","doc":"#### Breaking changes\n\n- Errors for `get_object` and `get_objects` are now of arity 4 and returns the original request as last attribute\n\n#### New\n\n- Added possibility to have multiple indexes for a model (applies for replicas as well)\n- Added `build_object/2` with the index name as second parameter (useful for translations for example)","ref":"changelog.html#v0-8-0-2024-09-11"},{"type":"extras","title":"v0.7.2 - 2023-09-18 - Changelog","doc":"#### Breaking changes\n\n- require Elixir >= 1.15 and OTP 26","ref":"changelog.html#v0-7-2-2023-09-18"},{"type":"extras","title":"v0.7.1 - 2022-03-29 - Changelog","doc":"#### New\n\n- Add wait_task/1 ( )","ref":"changelog.html#v0-7-1-2022-03-29"},{"type":"extras","title":"v0.7.0 - 2022-03-29 - Changelog","doc":"#### Breaking changes\n\n- Indexer operation returns a `%Algoliax.Reponse{}` (#51)\n\n#### Bug fix\n\n- Ensure clean up on reindex fail","ref":"changelog.html#v0-7-0-2022-03-29"},{"type":"extras","title":"v0.6.0 - 2021-06-10 - Changelog","doc":"#### Updates\n\n- Replace deprecated `hmac` function with new :crypto API `mac` function to support OTP-24\n\n#### Breaking changes\n\n- Drop support for OTP 21. OTP 22+ is now required.","ref":"changelog.html#v0-6-0-2021-06-10"},{"type":"extras","title":"v0.5.0 - 2021-03-04 - Changelog","doc":"#### New\n\n- [Welcome to the Jungle](https://www.welcometothejungle.com) became the owner :tada:\n- Add ability to define replicas\n- Raise when Algolia API error\n\n#### Breaking changes\n\n- `generate_secured_api_key/1` is removed in favor of `generate_secured_api_key/2`\n- Drop support of Elixir 1.9. Elixir 1.10 or greater required\n\n#### Updates\n\n- update hackney to 1.17","ref":"changelog.html#v0-5-0-2021-03-04"},{"type":"extras","title":"v0.4.3 - 2020-08-31 - Changelog","doc":"#### New\n\n- add ability to customize objectID by overriding `get_object_id/1`\n\n#### Improvement\n\n- Make sure index is configured before any action.","ref":"changelog.html#v0-4-3-2020-08-31"},{"type":"extras","title":"v0.4.2 - 2020-05-14 - Changelog","doc":"#### New\n\n- add ability to provide preloads for `reindex` and `reindex_atomic` function\n\n```elixir\ndefmodule People do\n  use Algoliax.Indexer,\n    index_name: :people,\n    object_id: :reference,\n    schemas: [\n      {__MODULE__, [:animals]}\n    ]\n    algolia: [\n      attribute_for_faceting: [\"age\"],\n      custom_ranking: [\"desc(updated_at)\"]\n    ]\n\nend\n```","ref":"changelog.html#v0-4-2-2020-05-14"},{"type":"extras","title":"v0.4.1 - 2020-05-01 - Changelog","doc":"#### New\n\n- add `generate_secured_api_key!/1`","ref":"changelog.html#v0-4-1-2020-05-01"},{"type":"extras","title":"v0.4.0 - 2020-04-24 - Changelog","doc":"#### New\n\n- add ability configure `:recv_timeout` for hackney.\n- add ability to pass query_filters or Ecto.Query to `reindex/2`.\n\n```elixir\nfilters = %{where: [name: \"John\"]}\nPeople.reindex(filters)\n\nquery = from(p in People, where: p.name == \"john\")\nPeople.reindex(query)\n```\n\n#### breaking changes\n\n- improved `generate_secured_api_key/1`\n- remove attributes macros in favor of `build_object/1`\n- remove `:prepare_object` options\n- remove `:preloads` options","ref":"changelog.html#v0-4-0-2020-04-24"},{"type":"extras","title":"v0.3.0 - 2020-04-04 - Changelog","doc":"#### New\n\n- add `prepare_object` to modify object before send to algolia\n- add ability to provide `build_object/1` instead of attributes\n- add `schemas` option to override caller\n\n#### Bug fix\n\n- Fix pagination when `cursor_field` different than `:id`\n- `delete_object/1` and `reindex` w/ `force_delete: true` don't need to build entire object\n\n#### breaking changes\n\n- change dependencies to optional (ecto)\n- Move algoliax to algoliax/indexer.\n\n```elixir\n# old\nuse Algoliax,\n  ...\n\n# New\nuse Algoliax.Indexer,\n  ...\n```\n\n- Move algolia specific settings into `:algolia` option\n\n```elixir\n# old\nuse Algoliax.Indexer,\n  index_name: :test,\n  attributes_for_faceting: [\"age\"],\n  searchable_attributes: [\"full_name\"],\n  custom_ranking: [\"desc(updated_at)\"],\n  ...\n\n# New\nuse Algoliax.Indexer,\n  index_name: :test,\n  algolia: [\n    attributes_for_faceting: [\"age\"],\n    searchable_attributes: [\"full_name\"],\n    custom_ranking: [\"desc(updated_at)\"]\n  ],\n  ...\n\n```","ref":"changelog.html#v0-3-0-2020-04-04"},{"type":"extras","title":"v0.2.0 - 2020-01-27 - Changelog","doc":"","ref":"changelog.html#v0-2-0-2020-01-27"},{"type":"extras","title":"Enhancements - Changelog","doc":"- add option to customize column used to find records in batch (`cursor_field`)\n- add preloads to find records in batch.","ref":"changelog.html#enhancements"},{"type":"extras","title":"License","doc":"# BSD-2-Clause License\n\nCopyright (c) 2020, CORUSCANT (welcome to the jungle) - https://www.welcometothejungle.com\nAll rights reserved.\n\nRedistribution and use in source and binary forms, with or without\nmodification, are permitted provided that the following conditions are met:\n\n1. Redistributions of source code must retain the above copyright notice, this\n   list of conditions and the following disclaimer.\n2. Redistributions in binary form must reproduce the above copyright notice,\n   this list of conditions and the following disclaimer in the documentation\n   and/or other materials provided with the distribution.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND\nANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\nWARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\nDISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR\nANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\nLOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\nON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\nSOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Algoliax\n\n[![CircleCI](https://circleci.com/gh/WTTJ/algoliax/tree/main.svg?style=svg)](https://circleci.com/gh/WTTJ/algoliax/tree/main)\n[![Module Version](https://img.shields.io/hexpm/v/algoliax.svg)](https://hex.pm/packages/algoliax)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/algoliax/)\n[![Total Download](https://img.shields.io/hexpm/dt/algoliax.svg)](https://hex.pm/packages/algoliax)\n[![License](https://img.shields.io/hexpm/l/algoliax.svg)](https://github.com/WTTJ/algoliax/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/WTTJ/algoliax.svg)](https://github.com/WTTJ/algoliax/commits/master)\n\nThis package let you easily integrate Algolia to your Elixir application. It can be used with built in Elixir struct or with [Ecto](https://github.com/elixir-ecto/ecto) schemas.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"The package can be installed by adding `:algoliax` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:algoliax, \"~> 0.7.0\"}\n  ]\nend\n```\n\nIf using with Ecto schemas, Algoliax requires `:ecto`.","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Overview","doc":"Algoliax needs only `:api_key` and `:application_id` config. These configs can either be on config files or using environment variables `ALGOLIA_API_KEY` and `ALGOLIA_APPLICATION_ID`.\n\n```elixir\nconfig :algoliax,\n  api_key: \" \",\n  application_id: \" \",\n  batch_size: 500,\n  recv_timeout: 5000\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - Overview","doc":"```elixir\ndefmodule People do\n  use Algoliax.Indexer,\n    index_name: :algoliax_people,\n    object_id: :reference,\n    algolia: [\n      attributes_for_faceting: [\"age\"],\n      searchable_attributes: [\"full_name\"],\n      custom_ranking: [\"desc(updated_at)\"]\n    ]\n\n  defstruct reference: nil, last_name: nil, first_name: nil, age: nil\nend\n```\n\nOverridable functions:\n\n- `to_be_indexed/1` which take the model struct in parameter: allows to choose to index or not the current model\n\n```elixir\ndefmodule People do\n  ...\n\n  @impl Algoliax\n  def to_be_indexed?(person) do\n    person.age > 20\n  end\nend\n\n# This object will be indexed\npeople1 = %People{reference: 10, last_name: \"Doe\", first_name: \"John\", age: 13}\n\n# This object will not be indexed\npeople2 = %People{reference: 87, last_name: \"Fred\", first_name: \"Al\", age: 70}\n```\n\n- `build_object/1` which take the model struct/map in parameter and should return a Map: allow to add attributes to the indexed object. By default the object contains only an `ObjectID`.\n\n```elixir\ndefmodule People do\n  ...\n\n  @impl Algoliax\n  def build_object(person) do\n    %{\n      age: person.age,\n      now: Date.utc_today()\n    }\n  end\nend\n```\n\n- `build_object/2` does the same but provides the current index name as a second parameter. Can be useful when indexing the same model on multiple indexes (ie. for translations).\n\n```elixir\ndefmodule Article do\n  ...\n\n  @impl Algoliax\n  def build_object(author, \"article_index_\" <> locale) do\n    %{\n      author: article.author,\n      content: article.content[locale]\n    }\n  end\nend\n```\n\n#### Index name at runtime\n\nIt's possible to define an index name at runtime, useful if `index_name` depends on environment or comes from an environment variable.\n\nTo do this just define a function with an arity of 0 that will be used as `index_name`\n\n```elixir\ndefmodule People do\n  use Algoliax.Indexer,\n    index_name: :algoliax_people,\n    object_id: :reference,\n    algolia: [...]\n\n  def algoliax_people do\n    System.get_env(\"PEOPLE_INDEX_NAME\")\n  end\nend\n```\n\n#### Multiple indexes\n\nIt's possible to define multiple indexes for a same model.\n\nTo achieve this, just specify an array of index names, or simply return an array in your `index_name/0` runtime function\n\n```elixir\ndefmodule Article do\n  use Algoliax.Indexer,\n    index_name: [:algoliax_article_fr, :algoliax_article_en],\n    object_id: :reference,\n    algolia: [...]\nend\n```\n\n#### Index functions\n\n```elixir\n# Get people index settings\nPeople.get_settings()\n\n# Delete index\nPeople.delete_index()\n\n# Configure index\nPeople.configure_index()\n```\n\n#### Object functions\n\n```elixir\n# Save object\nPeople.save_object(people1)\n\n# Save multiple objects\nPeople.save_objects([people1, people2])\n\n# Save multiple objects, and ensure object that they can't be indexed anymore are deleted from the index\nPeople.save_objects([people1, people2], force_delete: true)\n\n# Get object\nPeople.get_object(people1)\n\n# Delete object\nPeople.delete_object(people1)\n```\n\n#### Search functions\n\n```elixir\n# search in index\nPeople.search(\"john\")\n\n# search facet\nPeople.search_facet(\"age\")\n```\n\n#### Ecto specific\n\nFirst you will need to add the Repo to the algoliax config:\n\n```elixir\nuse Algoliax.Indexer,\n  index_name: :algoliax_people,\n  object_id: :reference\n  repo: MyApp.Repo,\n  algolia: [...]\n```\n\nIf using Agoliax with an Ecto schema it is possible to use `reindex` functions. Reindex will go through all entries in the corresponding table (or part if query is provided). Algoliax will save_objects by batch of 500.\n`batch_size` can be configured\n\n```elixir\nconfig :algoliax,\n  batch_size: 250\n```\n\n> **NOTE:** Algoliax use by default the `id` column to order and go through the table. (cf [Custom order column](#custom-order-column))\n\n```elixir\nimport Ecto.Query\n\n# Reindex all\nPeople.reindex()\n\n# Reindex all people with age greater than 20\nquery = from(p in People, where: p.age > 20)\nPeople.reindex(query)\n\n# Reindex can also `force_delete`\nquery = from(p in People, where: p.age > 20)\nPeople.reindex(query, force_delete: true)\nPeople.reindex(force_delete: true)\n\n# Reindex atomically (create a temporary index and move it to initial index)\nPeople.reindex_atomic()\n```\n\n##### Custom cursor column\n\nIf you don't have an `id` column, you can change it by setting the `cursor_field` option either in the global settings or in schema specific settings.\n\nMake sure this column ensure a consistent order even when new records are created.\n\n- Using the global config:\n\n```elixir\nconfig :algoliax,\n  batch_size: 250,\n  cursor_field: :reference\n```\n\n- Indexer specific:\n\n```elixir\ndefmodule People do\n  use Algoliax.Indexer,\n    index_name: :algoliax_people,\n    object_id: :reference,\n    repo: MyApp.Repo,\n    cursor_field: :inserted_at,\n    algolia: [...]\nend\n```\n\n#### Replicas configuration\n\nReplicas can be configured using `:replicas` options. This option accepts the following `:index_name`, `:algolia` and `:inherit`.\nUse `inherit: true` on the replica if you want it to inherit from the primary settings, if custom settings in `:algolia` they will be merged.\n\n```elixir\nuse Algoliax.Indexer,\n  index_name: :algoliax_people,\n  object_id: :reference,\n  repo: MyApp.Repo,\n  algolia: [\n    attributes_for_faceting: [\"age\"],\n    searchable_attributes: [\"full_name\"],\n  ],\n  replicas: [\n    [index_name: :algoliax_by_age_asc, inherit: true, algolia: [ranking: [\"asc(age)\"]]],\n    [index_name: :algoliax_by_age_desc, inherit: false, algolia: [ranking: [\"desc(age)\"]]]\n  ]\n```\n\nIf the main index holds multiple indexes (e.g for an index per language usecase), replicas need to hold the same amount of names.\nThe order is important to be associated to the correct main index.\n\n```elixir\nuse Algoliax.Indexer,\n  index_name: [:algoliax_article_en, :algoliax_article_fr],\n  object_id: :reference,\n  repo: MyApp.Repo,\n  algolia: [\n    attributes_for_faceting: [\"published_at\"],\n    searchable_attributes: [\"content\"],\n  ],\n  replicas: [\n    [index_name: [:algoliax_article_by_publication_asc_en, :algoliax_article_by_publication_asc_fr], inherit: true, algolia: [ranking: [\"asc(published_at)\"]]],\n    [index_name: [:algoliax_article_by_publication_desc_en, :algoliax_article_by_publication_desc_fr], inherit: false, algolia: [ranking: [\"desc(published_at)\"]]]\n  ]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2020 CORUSCANT (welcome to the jungle) - https://www.welcometothejungle.com\n\nThis library is licensed under the [BSD-2-Clause](./LICENSE.md).","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Global index example","doc":"# Global index example\n\nSometimes we need to aggregate multiple resource from multiple schema into a single algolia index.\n\nIn this example we want to make a global index with all our dogs and cats. First we need both ecto schemas:\n\n```elixir\ndefmodule MyApp.Cat do\n  use Ecto.Schema\n\n  schema \"cats\" do\n    field(:kind)\n    field(:name)\n    field(:weight, :integer)\n\n    timestamps()\n  end\nend\n\ndefmodule MyApp.Dog do\n  use Ecto.Schema\n\n  schema \"dogs\" do\n    field(:kind)\n    field(:name)\n    field(:weight, :integer)\n\n    timestamps()\n  end\nend\n```\n\nLet's build our global index using `:schemas` options\n\n```elixir\ndefmodule MyApp.GlobalIndex do\n  use Algoliax.Indexer,\n    index_name: :global_index_name,\n    repo: MyApp.Repo,\n    schemas: [\n      MyApp.Cat,\n      MyApp.Dog\n    ]\n    algolia: [\n      attributes_for_faceting: [\"resource_type\", \"resource.kind\"],\n      searchable_attributes: [\"resource.name\", \"resource.kind\"],\n      custom_ranking: [\"desc(updated_at)\"]\n    ]\n\n  def build_object(%MyApp.Cat{} = cat) do\n    %{\n      resource_type: \"cat\",\n      resource: %{\n        name: cat.name,\n        kind: cat.kind,\n        weigh: cat.weight\n      }\n    }\n  end\n\n  def build_object(%MyApp.Dog{} = dog) do\n    %{\n      resource_type: \"dog\",\n      resource:  %{\n        name: dog.name,\n        kind: dog.kind,\n        weigh: dog.weight\n      }\n    }\n  end\nend\n```\n\nNow you can just index your resources by using:\n\n```elixir\n# Reindex all\nMyApp.GlobalIndex.reindex()\n\n# Reindex only where dog or cat have name \"Kitty\" (why not for a dog)\nMyApp.GlobalIndex.reindex(%{where: [name: \"Kitty\"]})\n\n# Reindex only cat with name Kitty\nimport Ecto.Query\nquery = from(c in MyApp.Cat, where: c.name == \"Kitty\")\nMyApp.GlobalIndex.reindex(query)\n\n# Reindex all atomically\nMyApp.GlobalIndex.reindex_atomic()\n```","ref":"global.html"},{"type":"extras","title":"Generate a secured api key","doc":"# Generate a secured api key\n\n**NOTE**: Make sure to use a Search only api_key to generate secured api key.\n\n[See on algolia](https://www.algolia.com/doc/guides/security/api-keys/how-to/user-restricted-access-to-data/#generating-a-secured-api-key)\n\nAlgoliax allows to generate secured api key for example restrict access to a given user:\n\n```json\n[\n  {\n    \"title\": \"Catch Me If You Can\",\n    \"kind\": \"biography\",\n    \"objectID\": \"myID1\"\n  },\n  {\n    \"title\": \"The island\",\n    \"kind\": \"drama\",\n    \"objectID\": \"myID2\"\n  },\n  {\n    \"title\": \"Good Will Hunting\",\n    \"kind\": \"drama\",\n    \"objectID\": \"myID3\"\n  },\n  {\n    \"title\": \"Ferdinand\",\n    \"kind\": \"animation\",\n    \"objectID\": \"myID4\"\n  }\n]\n```\n\nValid params are `:filters`, `:validUntil`, `:restrictIndices`, `:restrictSources` and `:userToken`.\n\n```elixir\n# restrict access to drama movies\n{:ok, key} = Algoliax.generate_secured_api_key(\"api_key\", %{filters: \"kind:drama\"})\n\n# restrict access to drama and animation movies\n{:ok, key} = Algoliax.generate_secured_api_key(\"api_key\", %{filters: \"kind:drama OR kind:animation\"})\n\n# invalid params\n{:error, :invalid_params} = Algoliax.generate_secured_api_key(\"api_key\", %{whatever: \"test:10\"})\n```\n\nMoreover it's recommended to set the `:validUntil` params, so the key automatically expires after some time. It avoids having to delete the base key\n\n```elixir\n# restrict access to drama movies and expires in one hour\nvalid_until = DateTime.utc_now() |> DateTime.add(3600, :second) |> DateTime.to_unix()\n{:ok, key} = Algoliax.generate_secured_api_key(\"api_key\", %{filters: \"kind:drama\", validUntil: valid_until})\n```","ref":"secured_api_key.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}